# ===============================================================
# TestNumpyMatrixLibrary.py: Matrix library in numpy ...
# 
# ===============================================================

import numpy as np  # Make numpy available using np.
import numpy.matlib

# ===============================================================
# Function to print two-dimensional matrices ...
# ===============================================================

def PrintMatrix(a):
    for row in a:
        for col in row:
            print("{:8.2f}".format(col), end=" ")
        print("")

# ===============================================================
# main method ...
# ===============================================================

def main():
    print("--- Enter TestNumpyMatrixLibrary.main()      ... ");
    print("--- ======================================== ... ");

    # Part 1: Demonstrate numpy.matlib.empty() ...

    print("--- Part 1: Demonstrate numpy.matlib.empty()   ... ");

    A = numpy.matlib.empty((4,4));
    print(A)

    # Part 2: Demonstrate numpy.matlib.eye() ...

    print("--- Part 2: Demonstrate numpy.matlib.eye()   ... ");

    A = numpy.matlib.eye(4,4);
    print(A)

    # Part 3: Demonstrate numpy.matlib.identity() ...

    print("--- Part 3: Demonstrate numpy.matlib.identity()   ... ");

    A = numpy.matlib.identity(4,dtype=float);
    print(A)

    # Part 4: Demonstrate numpy.matlib.ones() ...

    print("--- Part 4: Demonstrate numpy.matlib.ones()   ... ");

    A = numpy.matlib.ones((4,4));
    print(A)

    # Part 5: Demonstrate numpy.matlib.ones() ...

    print("--- Part 5: Demonstrate numpy.matlib.rand()   ... ");

    A = numpy.matlib.rand(4,5);
    print(A)

    # Part 6: Demonstrate numpy.matlib.zeros() ...

    print("--- Part 6: Demonstrate numpy.matlib.zeros()   ... ");

    A = numpy.matlib.zeros((4,4));
    print(A)

    # Part 7: Demonstrate matrix shape manipulation ...

    print("--- Part 7: Demonstrate matrix shape manipulation ... ");

    A = np.random.random(20);
    print(A)

    print ( A.reshape(10,2) )

    # Part 8: Properties of two-dimensional array ...

    print("--- Part 8: Properties of two dimensional array ... ");

    B = np.array([[0,0],[0,1],[1,0],[1,1]], "float32")
    PrintMatrix(B)

    print("--- matrix shape: ", B.shape );

    print("--- ======================================== ... ");
    print("--- Leave TestNumpyMatrixLibrary.main()      ... ");

# call the main method ...

main()
