# ===============================================================
# TestTensors.py: Exercise tensor operations in TensorFlow 2. 
# 
# Written by: Mark Austin                              April 2021 
# ===============================================================

import tensorflow as tf
from tensorflow.python.framework import ops

# main method ...

def main():
    print("--- Enter TestTensors.main()                 ... ");
    print("--- ======================================== ... ");

    print("--- Basic Tensor ... ");

    # Introduce tensors in tf
 
    my_tensor = tf.zeros([1, 5])
    print(my_tensor)

    print("--- Declare and print variables ... ");

    # Declare a variable

    my_var = tf.Variable(tf.zeros([1, 20]))

    print(my_var)

    # Different kinds of variables

    row_dim = 2
    col_dim = 3

    # Zero initialized variable

    zero_var = tf.Variable(tf.zeros([row_dim, col_dim]))
    print(zero_var)

    # One initialized variable

    ones_var = tf.Variable(tf.ones([row_dim, col_dim]))
    print(ones_var)

    # Create a variable from a constant

    const_var = tf.Variable(tf.constant([8, 6, 7, 5, 3, 0, 9]))
    print(const_var)

    # This can also be used to fill an array:

    const_fill_var = tf.Variable(tf.constant(-1, shape=[row_dim, col_dim]))
    print(const_fill_var)

    print("--- Declare and print sequences ... ");

    # Sequence: generates [0.0, 0.5, 1.0] includes the end

    linear_var = tf.Variable(tf.linspace(start=0.0, stop=1.0, num=3))
    print(linear_var)

    # Sequence: generates [6, 9, 12], but doesn't include the end

    sequence_var = tf.Variable(tf.range(start=6, limit=15, delta=3))
    print(sequence_var)

    print("--- ======================================== ... ");
    print("--- Finished!! ... ");

# call the main method ...

main()
